## libquotient 0.8.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
if (POLICY CMP0092)
cmake_policy(SET CMP0092 NEW)
endif()

set(API_VERSION "0.8")
project(Quotient VERSION "${API_VERSION}.2" LANGUAGES CXX)

message(STATUS)
message(STATUS "Configuring ${PROJECT_NAME} ${PROJECT_VERSION} ==>")

include(FeatureSummary)
include(CTest)

# https://github.com/quotient-im/libQuotient/issues/369
option(${PROJECT_NAME}_ENABLE_E2EE "end-to-end encryption (E2EE) support" OFF)
add_feature_info(EnableE2EE ${PROJECT_NAME}_ENABLE_E2EE
                 "end-to-end encryption (WORK IN PROGRESS)")

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()
include(CheckCXXCompilerFlag)
if (MSVC)
    add_compile_options(/EHsc /W4
        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027)
else()
    foreach (FLAG all pedantic extra error=return-type) # Switch these on
        CHECK_CXX_COMPILER_FLAG("-W${FLAG}" W${FLAG}_SUPPORTED)
        if (W${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "W(no-)?${FLAG}($| )")
            add_compile_options(-W${FLAG})
        endif ()
    endforeach ()
    foreach (FLAG unused-parameter gnu-zero-variadic-macro-arguments
                  subobject-linkage) # Switch these off
        CHECK_CXX_COMPILER_FLAG("-Wno-${FLAG}" Wno-${FLAG}_SUPPORTED)
        if (Wno-${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "W(no-)?${FLAG}($| )")
            add_compile_options(-Wno-${FLAG})
        endif()
    endforeach ()
    # disable exceptions by default, not used in most parts here and saves about 10% binary size
    add_compile_options(-fno-exceptions)
endif()

add_compile_definitions(
    QT_NO_JAVA_STYLE_ITERATORS QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_TO_ASCII
    QT_NO_CAST_FROM_ASCII QT_STRICT_ITERATORS QT_NO_CAST_FROM_BYTEARRAY
    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT QT_NO_FOREACH)

set_directory_properties(PROPERTIES
    CXX_STANDARD 20
    CXX_EXTENSIONS OFF
    VISIBILITY_INLINES_HIDDEN ON
    CXX_VISIBILITY_PRESET hidden
)

option(BUILD_WITH_QT6 "Build Quotient with Qt 6 (EXPERIMENTAL)" OFF)
if (BUILD_WITH_QT6)
    set(QUOTIENT_LIB_NAME ${PROJECT_NAME}Qt6)
else()
    set(QUOTIENT_LIB_NAME ${PROJECT_NAME})
endif()

if (WIN32)
    if (NOT CMAKE_INSTALL_LIBDIR)
        set(CMAKE_INSTALL_LIBDIR ".")
        set(CMakeFilesLocation "cmake")
    else()
        set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${QUOTIENT_LIB_NAME}")
    endif()

    if (NOT CMAKE_INSTALL_BINDIR)
        set(CMAKE_INSTALL_BINDIR ".")
    endif()

    if (NOT CMAKE_INSTALL_INCLUDEDIR)
        set(CMAKE_INSTALL_INCLUDEDIR "include")
    endif()
else()
    include(GNUInstallDirs)
    set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${QUOTIENT_LIB_NAME}")
endif(WIN32)
set(${PROJECT_NAME}_INSTALL_INCLUDEDIR
        "${CMAKE_INSTALL_INCLUDEDIR}/" CACHE PATH
        "directory to install ${PROJECT_NAME} include files to")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

if (BUILD_WITH_QT6)
    set(QtMinVersion "6.0")
else()
    set(QtMinVersion "5.15")
    set(QtExtraModules "Multimedia") # See #483
endif()
string(REGEX REPLACE "^(.).*" "Qt\\1" Qt ${QtMinVersion}) # makes "Qt5" or "Qt6"
find_package(${Qt} ${QtMinVersion} REQUIRED Core Network Gui Test ${QtExtraModules})
get_filename_component(Qt_Prefix "${${Qt}_DIR}/../../../.." ABSOLUTE)

find_package(${Qt}Keychain REQUIRED)

if (${PROJECT_NAME}_ENABLE_E2EE)
    find_package(${Qt} ${QtMinVersion} REQUIRED Sql)
    find_package(Olm 3.2.5 REQUIRED)
    set_package_properties(Olm PROPERTIES
        DESCRIPTION "Implementation of the Olm and Megolm cryptographic ratchets"
        URL "https://gitlab.matrix.org/matrix-org/olm"
        TYPE REQUIRED
    )

    find_package(OpenSSL 1.1.0 REQUIRED)
    set_package_properties(OpenSSL PROPERTIES
        DESCRIPTION "Open source SSL and TLS implementation and cryptographic library"
        URL "https://www.openssl.org/"
        TYPE REQUIRED
    )
endif()

# Set up source files
list(APPEND lib_SRCS
    Quotient/quotient_common.h
    Quotient/quotient_export.h
    Quotient/function_traits.h Quotient/function_traits.cpp
    Quotient/omittable.h
    Quotient/expected.h
    Quotient/networkaccessmanager.h Quotient/networkaccessmanager.cpp
    Quotient/connectiondata.h Quotient/connectiondata.cpp
    Quotient/connection.h Quotient/connection.cpp
    Quotient/connection_p.h
    Quotient/ssosession.h Quotient/ssosession.cpp
    Quotient/logging_categories_p.h
    Quotient/room.h Quotient/room.cpp
    Quotient/roomstateview.h Quotient/roomstateview.cpp
    Quotient/user.h Quotient/user.cpp
    Quotient/roommember.h Quotient/roommember.cpp
    Quotient/avatar.h Quotient/avatar.cpp
    Quotient/uri.h Quotient/uri.cpp
    Quotient/uriresolver.h Quotient/uriresolver.cpp
    Quotient/eventstats.h Quotient/eventstats.cpp
    Quotient/syncdata.h Quotient/syncdata.cpp
    Quotient/settings.h Quotient/settings.cpp
    Quotient/networksettings.h Quotient/networksettings.cpp
    Quotient/converters.h Quotient/converters.cpp
    Quotient/util.h Quotient/util.cpp
    Quotient/eventitem.h Quotient/eventitem.cpp
    Quotient/accountregistry.h Quotient/accountregistry.cpp
    Quotient/mxcreply.h Quotient/mxcreply.cpp
    Quotient/e2ee/e2ee_common.h # because it's used by generated API
    Quotient/events/event.h Quotient/events/event.cpp
    Quotient/events/eventloader.h
    Quotient/events/roomevent.h Quotient/events/roomevent.cpp
    Quotient/events/stateevent.h Quotient/events/stateevent.cpp
    Quotient/events/single_key_value.h
    Quotient/events/simplestateevents.h
    Quotient/events/eventcontent.h Quotient/events/eventcontent.cpp
    Quotient/events/eventrelation.h Quotient/events/eventrelation.cpp
    Quotient/events/roomcreateevent.h Quotient/events/roomcreateevent.cpp
    Quotient/events/roomtombstoneevent.h Quotient/events/roomtombstoneevent.cpp
    Quotient/events/roommessageevent.h Quotient/events/roommessageevent.cpp
    Quotient/events/roommemberevent.h Quotient/events/roommemberevent.cpp
    Quotient/events/roomcanonicalaliasevent.h
    Quotient/events/roomavatarevent.h
    Quotient/events/roompowerlevelsevent.h Quotient/events/roompowerlevelsevent.cpp
    Quotient/events/typingevent.h
    Quotient/events/accountdataevents.h
    Quotient/events/receiptevent.h Quotient/events/receiptevent.cpp
    Quotient/events/reactionevent.h
    Quotient/events/callevents.h Quotient/events/callevents.cpp
    Quotient/events/directchatevent.h Quotient/events/directchatevent.cpp
    Quotient/events/encryptionevent.h Quotient/events/encryptionevent.cpp
    Quotient/events/encryptedevent.h Quotient/events/encryptedevent.cpp
    Quotient/events/roomkeyevent.h
    Quotient/events/stickerevent.h
    Quotient/events/filesourceinfo.h Quotient/events/filesourceinfo.cpp
    Quotient/jobs/requestdata.h Quotient/jobs/requestdata.cpp
    Quotient/jobs/basejob.h Quotient/jobs/basejob.cpp
    Quotient/jobs/syncjob.h Quotient/jobs/syncjob.cpp
    Quotient/jobs/mediathumbnailjob.h Quotient/jobs/mediathumbnailjob.cpp
    Quotient/jobs/downloadfilejob.h Quotient/jobs/downloadfilejob.cpp
    libquotientemojis.qrc
)
if (${PROJECT_NAME}_ENABLE_E2EE)
    list(APPEND lib_SRCS
        Quotient/database.h Quotient/database.cpp
        Quotient/connectionencryptiondata_p.h Quotient/connectionencryptiondata_p.cpp
        Quotient/keyverificationsession.h Quotient/keyverificationsession.cpp
        Quotient/e2ee/e2ee_common.cpp # .h is in the common sources list
        Quotient/e2ee/qolmaccount.h Quotient/e2ee/qolmaccount.cpp
        Quotient/e2ee/qolmsession.h Quotient/e2ee/qolmsession.cpp
        Quotient/e2ee/qolminboundsession.h Quotient/e2ee/qolminboundsession.cpp
        Quotient/e2ee/qolmoutboundsession.h Quotient/e2ee/qolmoutboundsession.cpp
        Quotient/e2ee/qolmutility.h Quotient/e2ee/qolmutility.cpp
        Quotient/e2ee/qolmsession.h Quotient/e2ee/qolmsession.cpp
        Quotient/e2ee/qolmmessage.h Quotient/e2ee/qolmmessage.cpp
        Quotient/e2ee/cryptoutils.h Quotient/e2ee/cryptoutils.cpp
        Quotient/e2ee/sssshandler.h Quotient/e2ee/sssshandler.cpp
        Quotient/events/keyverificationevent.h
    )
endif()

# Configure API files generation

set(CSAPI_DIR csapi)
set(FULL_CSAPI_DIR Quotient/${CSAPI_DIR})
set(ASAPI_DEF_DIR application-service/definitions)
set(ISAPI_DEF_DIR identity/definitions)

set(API_GENERATION_ENABLED 0)
if (NOT MATRIX_SPEC_PATH AND MATRIX_DOC_PATH)
    set(MATRIX_SPEC_PATH ${MATRIX_DOC_PATH})
endif()
if (GTAD_PATH AND MATRIX_SPEC_PATH)
    # REALPATH resolves ~ (home directory) while PROGRAM doesn't
    get_filename_component(ABS_GTAD_PATH "${GTAD_PATH}" REALPATH)
    get_filename_component(ABS_GTAD_PATH "${ABS_GTAD_PATH}" PROGRAM PROGRAM_ARGS GTAD_ARGS)
    if (EXISTS ${ABS_GTAD_PATH})
        get_filename_component(ABS_API_DEF_PATH "${MATRIX_SPEC_PATH}/data/api" REALPATH)
        if (NOT IS_DIRECTORY ${ABS_API_DEF_PATH})
            # Check the old place of API files
            get_filename_component(ABS_API_DEF_PATH "${MATRIX_SPEC_PATH}/api" REALPATH)
        endif ()
        if (IS_DIRECTORY ${ABS_API_DEF_PATH})
            set(API_GENERATION_ENABLED 1)
        else ()
            message( WARNING "${MATRIX_SPEC_PATH} doesn't seem to point to a valid matrix-doc repo; disabling API stubs generation")
        endif ()
    else (EXISTS ${ABS_GTAD_PATH})
        message( WARNING "${GTAD_PATH} is not executable; disabling API stubs generation")
    endif ()
endif ()
if (API_GENERATION_ENABLED)
    message( STATUS "Using GTAD at ${ABS_GTAD_PATH}" )
    message( STATUS "Found API files at ${ABS_API_DEF_PATH}" )
    if (NOT CLANG_FORMAT)
        set(CLANG_FORMAT clang-format)
    endif()
    get_filename_component(ABS_CLANG_FORMAT "${CLANG_FORMAT}" PROGRAM PROGRAM_ARGS CLANG_FORMAT_ARGS)
    if (NOT ABS_CLANG_FORMAT)
        message( WARNING "${CLANG_FORMAT} is NOT FOUND; API files won't be formatted")
    endif ()

    set(FULL_CSAPI_SRC_DIR ${ABS_API_DEF_PATH}/client-server)
    file(GLOB_RECURSE API_DEFS RELATIVE ${PROJECT_SOURCE_DIR}
        ${FULL_CSAPI_SRC_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ASAPI_DEF_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ISAPI_DEF_DIR}/*.yaml
    )
    add_custom_target(update-api
        ${ABS_GTAD_PATH} --config ../gtad/gtad.yaml --out ${CSAPI_DIR}
            ${FULL_CSAPI_SRC_DIR}
            old_sync.yaml- room_initial_sync.yaml- # deprecated
            sync.yaml- # we have a better handcrafted implementation
            ${GTAD_ARGS}
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/Quotient
        SOURCES gtad/gtad.yaml
                gtad/data.h.mustache
                gtad/operation.h.mustache
                gtad/operation.cpp.mustache
                ${API_DEFS}
        VERBATIM
    )
endif()
add_feature_info(EnableApiCodeGeneration "${API_GENERATION_ENABLED}"
                 "build target update-api")

# Produce the list of all Matrix API files for building the library. When this
# list changes (normally after calling GTAD), CONFIGURE_DEPENDS will force
# the build system to call CMake again. Checking for the glob change slows down
# each build (even if the target does not involve API generation). It would be
# ideal if GTAD could compare the initial (saved somewhere) and the generated
# file list itself and write down to some .cmake file if those are different,
# which would trigger the reconfiguration specifically before the next build.

=== autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Carl Schwan <carlschwan@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause

include(CMakeParseArguments)

add_custom_target(autotests ALL)

function(QUOTIENT_ADD_TEST)
    cmake_parse_arguments(ARG "" "NAME" "" ${ARGN})
    add_executable(${ARG_NAME} ${ARG_NAME}.cpp testutils.cpp)
    target_link_libraries(${ARG_NAME} ${Qt}::Core ${Qt}::Test ${QUOTIENT_LIB_NAME})
    add_test(NAME ${ARG_NAME} COMMAND ${ARG_NAME})
    add_dependencies(autotests ${ARG_NAME})
endfunction()

quotient_add_test(NAME callcandidateseventtest)
quotient_add_test(NAME utiltests)
if(${PROJECT_NAME}_ENABLE_E2EE)
    quotient_add_test(NAME testolmaccount)
    quotient_add_test(NAME testgroupsession)
    quotient_add_test(NAME testolmsession)
    if (NOT MSVC)
        target_compile_options(testolmsession PRIVATE -fexceptions)
    endif()
    quotient_add_test(NAME testolmutility)
    quotient_add_test(NAME testcryptoutils)
    quotient_add_test(NAME testkeyverification)
endif()

=== debian/changelog ===
libquotient (0.8.2-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix erroneous change of maintainer in last upload. Apologies.

 -- Simon Quigley <tsimonq2@debian.org>  Thu, 27 Feb 2025 15:41:18 -0600

libquotient (0.8.2-1.2) unstable; urgency=medium

  [ Rik Mills ]
  * debian/rules: Don't fail on removing debian/tmp/usr/bin/quotest if
    this was not produced by the build (i.e. on riscv64 in Ubuntu).

  [ Simon Quigley ]
  * Non-maintainer upload (Closes: #1095595).

 -- Simon Quigley <tsimonq2@debian.org>  Thu, 27 Feb 2025 14:12:22 -0600

libquotient (0.8.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable. (Closes: #1074110, #1089827)

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 21 Dec 2024 09:50:39 +0100

libquotient (0.8.2-1) experimental; urgency=medium

  * New upstream release.
  * Build with Qt6.

 -- Hubert Chathi <uhoreg@debian.org>  Thu, 15 Aug 2024 20:25:43 -0400

=== debian/control ===
Source: libquotient
Priority: optional
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
Build-Depends:
  debhelper-compat (= 12),
  cmake,
  libolm-dev,
  libssl-dev,
  qt6-base-dev,
  qt6-multimedia-dev,
  qtkeychain-qt6-dev,
  libqt6sql6-sqlite
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://salsa.debian.org/matrix-team/libquotient.git
Vcs-Browser: https://salsa.debian.org/matrix-team/libquotient

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libquotientqt6-0.8 (= ${binary:Version}), ${misc:Depends}, libolm-dev, libssl-dev
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, NeoChat and some other projects.

Package: libquotientqt6-0.8
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_INCLUDEDIR=include/libquotient -DBUILD_SHARED_LIBS=1 -DQuotient_ENABLE_E2EE=1 -DBUILD_WITH_QT6=1

override_dh_auto_install:
	dh_auto_install
# unused example file -- remove to avoid warning from dh_missing
	rm -f debian/tmp/usr/bin/quotest

override_dh_auto_test:
# testolmaccount needs a local synapse running, so skip it
# testverification writes to home directory, so make a dummy home directory for it
	mkdir debian/dummyhome
	HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
	rm -rf debian/dummyhome

## libquotient 0.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.26)
if (POLICY CMP0092)
cmake_policy(SET CMP0092 NEW)
endif()

set(API_VERSION "0.9")
project(Quotient VERSION "${API_VERSION}.1" LANGUAGES CXX)
set(PRE_STAGE "")
string(JOIN ~ FULL_VERSION ${PROJECT_VERSION} ${PRE_STAGE})

message(STATUS)
message(STATUS "Configuring ${PROJECT_NAME} ${FULL_VERSION} ==>")

include(FeatureSummary)
include(CTest)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build" FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()
include(CheckCXXCompilerFlag)
if (MSVC)
    add_compile_options(/EHsc /W4
        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027 /wd4702)
else()
    foreach (FLAG all pedantic extra error=return-type) # Switch these on
        CHECK_CXX_COMPILER_FLAG("-W${FLAG}" W${FLAG}_SUPPORTED)
        if (W${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "W(no-)?${FLAG}($| )")
            add_compile_options(-W${FLAG})
        endif ()
    endforeach ()
    foreach (FLAG unused-parameter gnu-zero-variadic-macro-arguments
                  subobject-linkage) # Switch these off
        CHECK_CXX_COMPILER_FLAG("-Wno-${FLAG}" Wno-${FLAG}_SUPPORTED)
        if (Wno-${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "W(no-)?${FLAG}($| )")
            add_compile_options(-Wno-${FLAG})
        endif()
    endforeach ()
    # disable exceptions by default, not used in most parts here and saves about 10% binary size
    add_compile_options(-fno-exceptions)
endif()

add_compile_definitions(
    QT_NO_JAVA_STYLE_ITERATORS QT_NO_URL_CAST_FROM_STRING QT_NO_CAST_TO_ASCII
    QT_NO_CAST_FROM_ASCII QT_STRICT_ITERATORS QT_NO_CAST_FROM_BYTEARRAY
    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT QT_NO_FOREACH)

set_directory_properties(PROPERTIES
    CXX_STANDARD 23
    CXX_EXTENSIONS OFF
    VISIBILITY_INLINES_HIDDEN ON
    CXX_VISIBILITY_PRESET hidden
)

set(QtMinVersion "6.4")
string(REGEX REPLACE "^(.).*" "Qt\\1" Qt ${QtMinVersion}) # makes "Qt<MajorVersionDigit>"
set(QUOTIENT_LIB_NAME ${PROJECT_NAME}${Qt})

if (WIN32)
    if (NOT CMAKE_INSTALL_LIBDIR)
        set(CMAKE_INSTALL_LIBDIR ".")
        set(CMakeFilesLocation "cmake")
    else()
        set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${QUOTIENT_LIB_NAME}")
    endif()

    if (NOT CMAKE_INSTALL_BINDIR)
        set(CMAKE_INSTALL_BINDIR ".")
    endif()

    if (NOT CMAKE_INSTALL_INCLUDEDIR)
        set(CMAKE_INSTALL_INCLUDEDIR "include")
    endif()
else()
    include(GNUInstallDirs)
    set(CMakeFilesLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${QUOTIENT_LIB_NAME}")
endif(WIN32)
set(${PROJECT_NAME}_INSTALL_INCLUDEDIR
        "${CMAKE_INSTALL_INCLUDEDIR}/" CACHE PATH
        "directory to install ${PROJECT_NAME} include files to")

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(${Qt} ${QtMinVersion} REQUIRED Core Network Gui Test Sql)
get_filename_component(Qt_Prefix "${${Qt}_DIR}/../../../.." ABSOLUTE)

find_package(${Qt}Keychain REQUIRED)

find_package(Olm 3.2.5 REQUIRED)
set_package_properties(Olm PROPERTIES
    DESCRIPTION "Implementation of the Olm and Megolm cryptographic ratchets"
    URL "https://gitlab.matrix.org/matrix-org/olm"
    TYPE REQUIRED
)

find_package(OpenSSL 1.1.0 REQUIRED)
set_package_properties(OpenSSL PROPERTIES
    DESCRIPTION "Open source SSL and TLS implementation and cryptographic library"
    URL "https://www.openssl.org/"
    TYPE REQUIRED
)

add_library(${QUOTIENT_LIB_NAME})

target_sources(${QUOTIENT_LIB_NAME} PUBLIC FILE_SET HEADERS BASE_DIRS .
    FILES
        Quotient/quotient_common.h
        Quotient/quotient_export.h
        Quotient/function_traits.h
        Quotient/omittable.h
        Quotient/expected.h
        Quotient/networkaccessmanager.h
        Quotient/connectiondata.h
        Quotient/connection.h
        Quotient/connection_p.h
        Quotient/ssosession.h
        Quotient/logging_categories_p.h
        Quotient/room.h
        Quotient/roomstateview.h
        Quotient/user.h
        Quotient/roommember.h
        Quotient/avatar.h
        Quotient/uri.h
        Quotient/uriresolver.h
        Quotient/eventstats.h
        Quotient/syncdata.h
        Quotient/settings.h
        Quotient/networksettings.h
        Quotient/converters.h
        Quotient/util.h
        Quotient/ranges_extras.h
        Quotient/eventitem.h
        Quotient/accountregistry.h
        Quotient/mxcreply.h
        Quotient/events/event.h
        Quotient/events/roomevent.h
        Quotient/events/stateevent.h
        Quotient/events/single_key_value.h
        Quotient/events/simplestateevents.h
        Quotient/events/eventcontent.h
        Quotient/events/eventrelation.h
        Quotient/events/roomcreateevent.h
        Quotient/events/roomtombstoneevent.h
        Quotient/events/roommessageevent.h
        Quotient/events/roommemberevent.h
        Quotient/events/roomcanonicalaliasevent.h
        Quotient/events/roomavatarevent.h
        Quotient/events/roompowerlevelsevent.h
        Quotient/events/typingevent.h
        Quotient/events/accountdataevents.h
        Quotient/events/receiptevent.h
        Quotient/events/reactionevent.h
        Quotient/events/callevents.h
        Quotient/events/directchatevent.h
        Quotient/events/encryptionevent.h
        Quotient/events/encryptedevent.h
        Quotient/events/roomkeyevent.h
        Quotient/events/stickerevent.h
        Quotient/events/filesourceinfo.h
        Quotient/events/redactionevent.h
        Quotient/jobs/requestdata.h
        Quotient/jobs/basejob.h
        Quotient/jobs/jobhandle.h
        Quotient/jobs/syncjob.h
        Quotient/jobs/mediathumbnailjob.h
        Quotient/jobs/downloadfilejob.h
        Quotient/database.h
        Quotient/connectionencryptiondata_p.h
        Quotient/keyverificationsession.h
        Quotient/e2ee/e2ee_common.h
        Quotient/e2ee/qolmaccount.h
        Quotient/e2ee/qolmsession.h
        Quotient/e2ee/qolminboundsession.h
        Quotient/e2ee/qolmoutboundsession.h
        Quotient/e2ee/qolmutility.h
        Quotient/e2ee/qolmsession.h
        Quotient/e2ee/qolmmessage.h
        Quotient/e2ee/cryptoutils.h
        Quotient/e2ee/sssshandler.h
        Quotient/events/keyverificationevent.h
        Quotient/keyimport.h
        Quotient/qt_connection_util.h
    PRIVATE
        Quotient/function_traits.cpp
        Quotient/networkaccessmanager.cpp
        Quotient/connectiondata.cpp
        Quotient/connection.cpp
        Quotient/ssosession.cpp
        Quotient/room.cpp
        Quotient/roomstateview.cpp
        Quotient/user.cpp
        Quotient/roommember.cpp
        Quotient/avatar.cpp
        Quotient/uri.cpp
        Quotient/uriresolver.cpp
        Quotient/eventstats.cpp
        Quotient/syncdata.cpp
        Quotient/settings.cpp
        Quotient/networksettings.cpp
        Quotient/converters.cpp
        Quotient/util.cpp
        Quotient/eventitem.cpp
        Quotient/accountregistry.cpp
        Quotient/mxcreply.cpp
        Quotient/events/event.cpp
        Quotient/events/roomevent.cpp
        Quotient/events/stateevent.cpp
        Quotient/events/eventcontent.cpp
        Quotient/events/eventrelation.cpp
        Quotient/events/roomcreateevent.cpp
        Quotient/events/roomtombstoneevent.cpp
        Quotient/events/roommessageevent.cpp
        Quotient/events/roommemberevent.cpp
        Quotient/events/roompowerlevelsevent.cpp
        Quotient/events/receiptevent.cpp
        Quotient/events/callevents.cpp
        Quotient/events/directchatevent.cpp
        Quotient/events/encryptionevent.cpp
        Quotient/events/encryptedevent.cpp
        Quotient/events/filesourceinfo.cpp
        Quotient/jobs/requestdata.cpp
        Quotient/jobs/basejob.cpp
        Quotient/jobs/syncjob.cpp
        Quotient/jobs/mediathumbnailjob.cpp
        Quotient/jobs/downloadfilejob.cpp
        Quotient/database.cpp
        Quotient/connectionencryptiondata_p.cpp
        Quotient/keyverificationsession.cpp
        Quotient/e2ee/e2ee_common.cpp
        Quotient/e2ee/qolmaccount.cpp
        Quotient/e2ee/qolmsession.cpp
        Quotient/e2ee/qolminboundsession.cpp
        Quotient/e2ee/qolmoutboundsession.cpp
        Quotient/e2ee/qolmutility.cpp
        Quotient/e2ee/qolmsession.cpp
        Quotient/e2ee/qolmmessage.cpp
        Quotient/e2ee/cryptoutils.cpp
        Quotient/e2ee/sssshandler.cpp
        Quotient/keyimport.cpp
        libquotientemojis.qrc
)

# Configure API files generation

set(CSAPI_DIR csapi)
set(FULL_CSAPI_DIR Quotient/${CSAPI_DIR})
set(ASAPI_DEF_DIR application-service/definitions)

set(API_GENERATION_ENABLED 0)
if (NOT MATRIX_SPEC_PATH AND MATRIX_DOC_PATH)
    set(MATRIX_SPEC_PATH ${MATRIX_DOC_PATH})
endif()
if (GTAD_PATH AND MATRIX_SPEC_PATH)
    # REALPATH resolves ~ (home directory) while PROGRAM doesn't
    get_filename_component(ABS_GTAD_PATH "${GTAD_PATH}" REALPATH)
    get_filename_component(ABS_GTAD_PATH "${ABS_GTAD_PATH}" PROGRAM PROGRAM_ARGS GTAD_ARGS)
    if (EXISTS ${ABS_GTAD_PATH})
        get_filename_component(ABS_API_DEF_PATH "${MATRIX_SPEC_PATH}/data/api" REALPATH)
        if (NOT IS_DIRECTORY ${ABS_API_DEF_PATH})
            # Check the old place of API files
            get_filename_component(ABS_API_DEF_PATH "${MATRIX_SPEC_PATH}/api" REALPATH)
        endif ()
        if (IS_DIRECTORY ${ABS_API_DEF_PATH})
            set(API_GENERATION_ENABLED 1)
        else ()
            message( WARNING "${MATRIX_SPEC_PATH} doesn't seem to point to a valid matrix-doc repo; disabling API stubs generation")
        endif ()
    else (EXISTS ${ABS_GTAD_PATH})
        message( WARNING "${GTAD_PATH} is not executable; disabling API stubs generation")
    endif ()
endif ()
if (API_GENERATION_ENABLED)
    message( STATUS "Using GTAD at ${ABS_GTAD_PATH}" )
    message( STATUS "Found API files at ${ABS_API_DEF_PATH}" )
    if (NOT CLANG_FORMAT)
        set(CLANG_FORMAT clang-format)
    endif()
    get_filename_component(ABS_CLANG_FORMAT "${CLANG_FORMAT}" PROGRAM PROGRAM_ARGS CLANG_FORMAT_ARGS)
    if (NOT ABS_CLANG_FORMAT)
        message( WARNING "${CLANG_FORMAT} is NOT FOUND; API files won't be formatted")
    endif ()

    set(FULL_CSAPI_SRC_DIR ${ABS_API_DEF_PATH}/client-server)
    file(GLOB_RECURSE API_DEFS RELATIVE ${PROJECT_SOURCE_DIR}
        ${FULL_CSAPI_SRC_DIR}/*.yaml
        ${ABS_API_DEF_PATH}/${ASAPI_DEF_DIR}/*.yaml
    )
    add_custom_target(update-api
        ${ABS_GTAD_PATH} --config ../gtad/gtad.yaml --out ${CSAPI_DIR}
            ${FULL_CSAPI_SRC_DIR}
            old_sync.yaml- room_initial_sync.yaml- # deprecated
            sync.yaml- # we have a better handcrafted implementation
            ${GTAD_ARGS}
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/Quotient
        SOURCES gtad/gtad.yaml
                gtad/data.h.mustache
                gtad/operation.h.mustache
                gtad/operation.cpp.mustache
                gtad/preamble.mustache
                gtad/define_models.mustache
                ${API_DEFS}
        VERBATIM
    )
endif()
add_feature_info(EnableApiCodeGeneration "${API_GENERATION_ENABLED}"
                 "build target update-api")

# Produce the list of all Matrix API files for building the library. When this
# list changes (normally after calling GTAD), CONFIGURE_DEPENDS will force
# the build system to call CMake again. Checking for the glob change slows down
# each build (even if the target does not involve API generation). It would be

=== autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Carl Schwan <carlschwan@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause

include(CMakeParseArguments)

add_custom_target(autotests ALL)

function(QUOTIENT_ADD_TEST)
    cmake_parse_arguments(ARG "" "NAME" "" ${ARGN})
    add_executable(${ARG_NAME} ${ARG_NAME}.cpp testutils.h testutils.cpp)
    target_link_libraries(${ARG_NAME} ${Qt}::Core ${Qt}::Test ${QUOTIENT_LIB_NAME})
    add_test(NAME ${ARG_NAME} COMMAND ${ARG_NAME})
    add_dependencies(autotests ${ARG_NAME})
endfunction()

quotient_add_test(NAME callcandidateseventtest)
quotient_add_test(NAME utiltests)
quotient_add_test(NAME testolmaccount)
quotient_add_test(NAME testgroupsession)
quotient_add_test(NAME testolmsession)
if (NOT MSVC)
    target_compile_options(testolmsession PRIVATE -fexceptions)
endif()
quotient_add_test(NAME testolmutility)
quotient_add_test(NAME testcryptoutils)
quotient_add_test(NAME testkeyverification)
quotient_add_test(NAME testcrosssigning)
quotient_add_test(NAME testkeyimport)

=== debian/changelog ===
libquotient (0.9.1-0ubuntu1) plucky; urgency=medium

  * New upstream release (0.9.1). Required for latest KDE neochat.
  * Update build deps.
  * Rename library package according to SONAME bump. 0.8 to 0.9

 -- Rik Mills <rikmills@ubuntu.com>  Fri, 22 Nov 2024 10:36:04 +0000

libquotient (0.8.2-1ubuntu1) plucky; urgency=medium

  * debian/rules: Don't fail on removing debian/tmp/usr/bin/quotest if
    this was not produced by the build (i.e. on riscv64 in Ubuntu).

 -- Rik Mills <rikmills@kde.org>  Tue, 29 Oct 2024 19:45:58 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libquotient
 Priority: optional
-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
 Build-Depends:
   debhelper-compat (= 12),
@@ -8,6 +9,7 @@
   libolm-dev,
   libssl-dev,
   qt6-base-dev,
+  qt6-base-private-dev,
   qt6-multimedia-dev,
   qtkeychain-qt6-dev,
   libqt6sql6-sqlite
@@ -20,12 +22,12 @@
 Package: libquotient-dev
 Section: libdevel
 Architecture: any
-Depends: libquotientqt6-0.8 (= ${binary:Version}), ${misc:Depends}, libolm-dev, libssl-dev
+Depends: libquotientqt6-0.9 (= ${binary:Version}), ${misc:Depends}, libolm-dev, libssl-dev
 Description: Qt6 library to write cross-platform clients for Matrix
  libQuotient is a Qt6-based library to make IM clients for the Matrix
  protocol. It is the backbone of Quaternion, NeoChat and some other projects.
 
-Package: libquotientqt6-0.8
+Package: libquotientqt6-0.9
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Qt6 library to write cross-platform clients for Matrix

## libquotient 0.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif()
 
 set(API_VERSION "0.9")
-project(Quotient VERSION "${API_VERSION}.1" LANGUAGES CXX)
+project(Quotient VERSION "${API_VERSION}.2" LANGUAGES CXX)
 set(PRE_STAGE "")
 string(JOIN ~ FULL_VERSION ${PROJECT_VERSION} ${PRE_STAGE})
 
@@ -190,6 +190,7 @@
         Quotient/events/keyverificationevent.h
         Quotient/keyimport.h
         Quotient/qt_connection_util.h
+        Quotient/thread.h
     PRIVATE
         Quotient/function_traits.cpp
         Quotient/networkaccessmanager.cpp
@@ -247,6 +248,7 @@
         Quotient/e2ee/cryptoutils.cpp
         Quotient/e2ee/sssshandler.cpp
         Quotient/keyimport.cpp
+        Quotient/thread.cpp
         libquotientemojis.qrc
 )

=== debian/changelog ===
libquotient (0.9.2-0ubuntu1) plucky; urgency=medium

  * New upstream release.
  * Bump to debhelper 13, Standards-version 4.7.0. No changes needed.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 16 Feb 2025 23:03:28 -0600

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
 Uploaders: Hubert Chathi <uhoreg@debian.org>, Andres Salomon <dilinger@debian.org>
 Build-Depends:
-  debhelper-compat (= 12),
+  debhelper-compat (= 13),
   cmake,
   libolm-dev,
   libssl-dev,
@@ -13,7 +13,7 @@
   qt6-multimedia-dev,
   qtkeychain-qt6-dev,
   libqt6sql6-sqlite
-Standards-Version: 4.3.0
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/quotient-im/libQuotient
 Vcs-Git: https://salsa.debian.org/matrix-team/libquotient.git

=== debian/rules ===
--- 
+++ 
@@ -16,5 +16,5 @@
 # testolmaccount needs a local synapse running, so skip it
 # testverification writes to home directory, so make a dummy home directory for it
 	mkdir debian/dummyhome
-	HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
+	-HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
 	rm -rf debian/dummyhome

## libquotient 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif()
 
 set(API_VERSION "0.9")
-project(Quotient VERSION "${API_VERSION}.2" LANGUAGES CXX)
+project(Quotient VERSION "${API_VERSION}.3" LANGUAGES CXX)
 set(PRE_STAGE "")
 string(JOIN ~ FULL_VERSION ${PROJECT_VERSION} ${PRE_STAGE})

=== debian/changelog ===
libquotient (0.9.3-4) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Update symbols from buildds for 0.9.3.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 13 Aug 2025 11:33:29 +0200

libquotient (0.9.3-3) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 12 Aug 2025 07:55:22 +0200

libquotient (0.9.3-2) experimental; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * Update symbols from buildds for 0.9.3.
  * Use dh-sequence-pkgkde-symbolshelper for symbols handling.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 12 Apr 2025 23:42:00 +0200

libquotient (0.9.3-1) experimental; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (0.9.3).
  * Update build-deps and deps with the info from cmake.
  * Disable __FILE__ mangling to unbreak tests.
  * Bump library soname to libquotientqt6-0.9.
  * Build with hardening=+all build hardening flag.
  * Adopt the library under the Qt/KDE Team’s maintainership after
    discussing with Hubert Chathi.
  * Bump Standards-Version to 4.7.2, no change required.
  * Remove dh_make template from watch file comments.
  * Add lintian overrides for LGPLv2.1 text using the old FSF address.
  * Add ABI symbols tracking file.
  * Improve package descriptions.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 07 Apr 2025 08:00:25 +0200

=== debian/control ===
Source: libquotient
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>,
           Andres Salomon <dilinger@debian.org>,
Build-Depends: debhelper-compat (= 12),
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.26~),
               libolm-dev (>= 3.2.5~),
               libqt6sql6-sqlite,
               libssl-dev (>= 1.1.0~),
               qt6-base-dev (>= 6.4.0~),
               qt6-base-private-dev,
               qt6-multimedia-dev,
               qtkeychain-qt6-dev,
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/libquotient.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/libquotient

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libolm-dev,
         libquotientqt6-0.9 (= ${binary:Version}),
         libssl-dev (>= 1.1.0~),
         ${misc:Depends},
Description: Qt6 library to write cross-platform clients for Matrix - development files
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, NeoChat and some other projects.
 .
 This package contains the development files for libQuotient.

Package: libquotientqt6-0.9
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=-fixfilepath
 
 %:
 	dh $@
@@ -16,5 +18,5 @@
 # testolmaccount needs a local synapse running, so skip it
 # testverification writes to home directory, so make a dummy home directory for it
 	mkdir debian/dummyhome
-	-HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
+	HOME=$(CURDIR)/debian/dummyhome dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount
 	rm -rf debian/dummyhome

## libquotient 0.9.4

=== debian/changelog ===
libquotient (0.9.4-0zneon+24.04+noble+stable+build3) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Sat, 13 Sep 2025 02:44:43 +0000

libquotient (0.9.4-0neon) noble; urgency=medium

  * New release

 -- Carlos De Maine <carlosd.kde@gmail.com>  Sat, 13 Sep 2025 12:43:22 +1000

libquotient (0.9.2-0neon) noble; urgency=medium

  [ Jonathan Riddell ]
  * New release

  [ Carlos De Maine ]
  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Sat, 22 Feb 2025 07:24:29 +1000

=== debian/control ===
Source: libquotient
Priority: optional
Uploaders: Hubert Chathi <uhoreg@debian.org>,
           Andres Salomon <dilinger@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libolm-dev,
               libqt6sql6-sqlite,
               libssl-dev,
               qt6-base-dev,
               qt6-multimedia-dev,
               qtkeychain-qt6-dev
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://invent.kde.org/neon/forks/libquotient.git
Vcs-Browser: https://invent.kde.org/neon/forks/libquotient
Maintainer: Neon CI <neon@kde.org>

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libolm-dev,
         libquotientqt6-0.9 (= ${binary:Version}),
         libssl-dev,
         ${misc:Depends}
Breaks: libquotient-qt5-dev (<< 0.9), libquotient-qt6-dev (<< 0.9)
Replaces: libquotient-qt5-dev (<< 0.9), libquotient-qt6-dev (<< 0.9)
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, NeoChat and some other projects.

Package: libquotientqt6-0.9
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

Package: libquotient-qt5-dev
Section: oldlibs
Priority: extra
Architecture: all
Depends: libquotient-dev (= ${binary:Version}), ${misc:Depends}
Description: Empty transitional
 Dummy package

Package: libquotient-qt6-dev
Section: oldlibs
Priority: extra
Architecture: all
Depends: libquotient-dev (= ${binary:Version}), ${misc:Depends}
Description: Empty transitional
 Dummy package

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/quotient-im/libQuotient/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libquotient 0.9.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 endif()
 
 set(API_VERSION "0.9")
-project(Quotient VERSION "${API_VERSION}.3" LANGUAGES CXX)
+project(Quotient VERSION "${API_VERSION}.5" LANGUAGES CXX)
 set(PRE_STAGE "")
 string(JOIN ~ FULL_VERSION ${PROJECT_VERSION} ${PRE_STAGE})
 
@@ -93,6 +93,10 @@
 
 find_package(${Qt} ${QtMinVersion} REQUIRED Core Network Gui Test Sql)
 get_filename_component(Qt_Prefix "${${Qt}_DIR}/../../../.." ABSOLUTE)
+
+if(${Qt}Core_VERSION VERSION_GREATER_EQUAL 6.10)
+    find_package(${Qt} ${QtMinVersion} REQUIRED COMPONENTS CorePrivate)
+endif()
 
 find_package(${Qt}Keychain REQUIRED)
 
@@ -319,5 +323,3 @@
 
 # Produce the list of all Matrix API files for building the library. When this
 # list changes (normally after calling GTAD), CONFIGURE_DEPENDS will force
-# the build system to call CMake again. Checking for the glob change slows down
-# each build (even if the target does not involve API generation). It would be

=== autotests/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,8 @@
 include(CMakeParseArguments)
 
 add_custom_target(autotests ALL)
+
+add_definitions(-DDATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data" )
 
 function(QUOTIENT_ADD_TEST)
     cmake_parse_arguments(ARG "" "NAME" "" ${ARGN})
@@ -27,3 +29,5 @@
 quotient_add_test(NAME testkeyverification)
 quotient_add_test(NAME testcrosssigning)
 quotient_add_test(NAME testkeyimport)
+quotient_add_test(NAME testsettings)
+quotient_add_test(NAME testthread)

=== quotest/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021 Carl Schwan <carlschwan@kde.org>
#
# SPDX-License-Identifier: BSD-3-Clause

set(quotest_SRCS quotest.cpp)

find_package(${Qt} COMPONENTS Concurrent)
add_executable(quotest ${quotest_SRCS})
target_link_libraries(quotest PRIVATE ${Qt}::Core ${Qt}::Test ${Qt}::Concurrent ${QUOTIENT_LIB_NAME})

if (MSVC)
    target_compile_options(quotest PUBLIC /EHsc /W4
        /wd4100 /wd4127 /wd4242 /wd4244 /wd4245 /wd4267 /wd4365 /wd4456 /wd4459
        /wd4464 /wd4505 /wd4514 /wd4571 /wd4619 /wd4623 /wd4625 /wd4626 /wd4706
        /wd4710 /wd4774 /wd4820 /wd4946 /wd5026 /wd5027)
else()
    foreach (FLAG W Wall Wpedantic Wextra Wno-unused-parameter Werror=return-type)
        CHECK_CXX_COMPILER_FLAG("-${FLAG}" COMPILER_${FLAG}_SUPPORTED)
        if (COMPILER_${FLAG}_SUPPORTED AND
                NOT CMAKE_CXX_FLAGS MATCHES "(^| )-?${FLAG}($| )")
            target_compile_options(quotest PUBLIC -${FLAG})
        endif ()
    endforeach ()
endif()

option(${PROJECT_NAME}_INSTALL_TESTS "install quotest application" ON)
add_feature_info(InstallQuotest ${PROJECT_NAME}_INSTALL_TESTS
                 "the library functional test suite")

if (${PROJECT_NAME}_INSTALL_TESTS)
    install(TARGETS quotest RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif ()

=== debian/changelog ===
libquotient (0.9.5-2) unstable; urgency=medium

  * Team upload.
  * Update symbols files from the logs of buildds.

 -- Pino Toscano <pino@debian.org>  Sat, 11 Oct 2025 08:38:55 +0200

libquotient (0.9.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop creating an empty directory as $HOME when running dh_auto_test, as
      debhelper does it automatically
  * Add the configuration for the CI on salsa.
  * Drop the .dirs files, as all the needed directories are automatically
    created by dh_install.
  * Drop debian/gbp.conf, not actually needed.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.
  * Update the build dependencies according to the upstream build system:
    - drop qt6-multimedia-dev, not used
  * Drop -DQuotient_ENABLE_E2EE=1 -DBUILD_WITH_QT6=1 from the cmake arguments,
    as they are no more needed.
  * Update symbols file. (Closes: #1114181)
  * Avoid shipping /usr/share/ndk-modules/Android.mk by removing it from
    debian/tmp, as done for other bits
    - drop debian/not-installed, no more needed now
  * Improve the install files to be more specific.
  * Mark libquotientqt6-0.9 as Multi-Arch: same.
  * Add a simple debian/upstream/metadata file.

 -- Pino Toscano <pino@debian.org>  Sat, 11 Oct 2025 06:59:55 +0200

=== debian/control ===
Source: libquotient
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Hubert Chathi <uhoreg@debian.org>,
           Andres Salomon <dilinger@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-pkgkde-symbolshelper,
               cmake (>= 3.26~),
               libolm-dev (>= 3.2.5~),
               libqt6sql6-sqlite,
               libssl-dev (>= 1.1.0~),
               qt6-base-dev (>= 6.4.0~),
               qt6-base-private-dev,
               qtkeychain-qt6-dev,
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/quotient-im/libQuotient
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/libquotient.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/libquotient

Package: libquotient-dev
Section: libdevel
Architecture: any
Depends: libolm-dev,
         libquotientqt6-0.9 (= ${binary:Version}),
         libssl-dev (>= 1.1.0~),
         ${misc:Depends},
Description: Qt6 library to write cross-platform clients for Matrix - development files
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, NeoChat and some other projects.
 .
 This package contains the development files for libQuotient.

Package: libquotientqt6-0.9
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Qt6 library to write cross-platform clients for Matrix
 libQuotient is a Qt6-based library to make IM clients for the Matrix
 protocol. It is the backbone of Quaternion, Spectral and some other projects.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=-fixfilepath

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_INCLUDEDIR=include/libquotient -DBUILD_SHARED_LIBS=1

execute_after_dh_auto_install:
# for android
	rm -f debian/tmp/usr/share/ndk-modules/Android.mk
# unused example file
	rm -f debian/tmp/usr/bin/quotest

override_dh_auto_test:
# testolmaccount needs a local synapse running, so skip it
	dh_auto_test -- ARGS\+=-E ARGS\+=testolmaccount

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/quotient-im/libQuotient/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
